{ copyright  Grahame Grieve
  refer to xyGraph.pas, xyGraph.hlp for more information }

unit Xydatwiz;

{$I xyDefine.pas}

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, ExtCtrls, {$IFDEF WIN32} ComCtrls, {$ENDIF}
  Grids, Spin, FileCtrl, Tabnotbk, xyGraph, xyData, xyGetSrc;

type
  TxyDataWizard = class(TForm)
    Panel1: TPanel;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    fd: TFontDialog;
    cd: TColorDialog;
    Notebook2: TNotebook;
    fgraph: TxyGraph;
    Panel2: TPanel;
    Label27: TLabel;
    seriesCombobox: TComboBox;
    BitBtn18: TBitBtn;
    Button5: TButton;
    TabbedNotebook1: TTabbedNotebook;
    Label71: TLabel;
    e_Zero: TEdit;
    cb_AutoZero: TCheckBox;
    Label15: TLabel;
    cbx_Lines: TComboBox;
    cbx_points: TComboBox;
    Label13: TLabel;
    Label14: TLabel;
    b_LineColor: TButton;
    e_PointSize: TSpinEdit;
    Label65: TLabel;
    b_PointColor: TButton;
    RadioButton7: TRadioButton;
    RadioButton6: TRadioButton;
    Label61: TLabel;
    cb_Active: TCheckBox;
    Label16: TLabel;
    Bevel3: TBevel;
    Bevel6: TBevel;
    Bevel8: TBevel;
    Label43: TLabel;
    cbx_Bounds: TComboBox;
    Label47: TLabel;
    cbx_BoundsLine: TComboBox;
    b_BoundsColor: TButton;
    e_BoundLow: TEdit;
    Label45: TLabel;
    b_RegrColor: TButton;
    e_RegCtrl2: TEdit;
    e_RegCtrl1: TEdit;
    l_RegCtrl1: TLabel;
    l_RegCtrl2: TLabel;
    Bevel4: TBevel;
    cbx_RegrLine: TComboBox;
    Label75: TLabel;
    cbx_Regression: TComboBox;
    Label78: TLabel;
    Label17: TLabel;
    Bevel5: TBevel;
    Panel3: TPanel;
    cbx_Source: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    e_source: TEdit;
    Button1: TButton;
    Panel6: TPanel;
    Notebook1: TNotebook;
    Panel5: TPanel;
    Label26: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    e_width: TSpinEdit;
    cbx_Colselecttype: TComboBox;
    cbx_Xcol: TComboBox;
    cbx_YCol: TComboBox;
    Panel4: TPanel;
    Label7: TLabel;
    Label8: TLabel;
    Label18: TLabel;
    Label6: TLabel;
    e_Headers: TSpinEdit;
    e_RowFreq: TSpinEdit;
    e_start: TEdit;
    cbx_RowChoice: TComboBox;
    e_end: TEdit;
    Panel7: TPanel;
    cb_Duplicates: TCheckBox;
    Label5: TLabel;
    e_tolerance: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    Label4: TLabel;
    e_SeriesName: TEdit;
    Bevel1: TBevel;
    e_boundUp: TEdit;
    Grid: TStringGrid;
    SpeedButton4: TSpeedButton;
    SpeedButton5: TSpeedButton;
    od: TOpenDialog;
    CheckBox1: TCheckBox;
    Bevel2: TBevel;
    Bevel7: TBevel;
    Bevel9: TBevel;
    procedure BitBtn3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure e_SeriesNameChange(Sender: TObject);
    procedure cb_DuplicatesClick(Sender: TObject);
    procedure e_toleranceChange(Sender: TObject);
    procedure cbx_pointsChange(Sender: TObject);
    procedure b_PointColorClick(Sender: TObject);
    procedure e_PointSizeChange(Sender: TObject);
    procedure cbx_LinesChange(Sender: TObject);
    procedure b_LineColorClick(Sender: TObject);
    procedure cb_ActiveClick(Sender: TObject);
    procedure RadioButton6Click(Sender: TObject);
    procedure cb_AutoZeroClick(Sender: TObject);
    procedure e_ZeroChange(Sender: TObject);
    procedure cbx_RegressionChange(Sender: TObject);
    procedure e_RegCtrl1Change(Sender: TObject);
    procedure e_RegCtrl2Change(Sender: TObject);
    procedure cbx_RegrLineChange(Sender: TObject);
    procedure b_RegrColorClick(Sender: TObject);
    procedure cbx_BoundsChange(Sender: TObject);
    procedure e_BoundLowChange(Sender: TObject);
    procedure e_BoundUpChange(Sender: TObject);
    procedure cbx_BoundsLineChange(Sender: TObject);
    procedure b_BoundsColorClick(Sender: TObject);
    procedure seriesComboboxChange(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure BitBtn18Click(Sender: TObject);
    procedure e_HeadersChange(Sender: TObject);
    procedure e_RowFreqChange(Sender: TObject);
    procedure cbx_SourceChange(Sender: TObject);
    procedure cbx_RowChoiceChange(Sender: TObject);
    procedure e_startChange(Sender: TObject);
    procedure e_endChange(Sender: TObject);
    procedure cbx_ColselecttypeChange(Sender: TObject);
    procedure e_widthChange(Sender: TObject);
    procedure cbx_XcolChange(Sender: TObject);
    procedure cbx_YColChange(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure e_SourceDblClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure e_sourceChange(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
  private
    { Private declarations }
    InPreview,FNoUpdating, WasManual:Boolean;
    FSeries:TSeries;
    FGridOffset:integer;
    procedure showseries(i:integer);
    procedure SetxyGraph(AxyGraph:TxyGraph);
    procedure BuildSeriesComboBox(i:integer);
    procedure SetDefaults;
    procedure upDateDataControls;
    procedure ClearGrid;
    procedure setupgrid(ds:TDataSupplier);
    Procedure AddHeaderRows(ds:TDataSupplier);
    procedure SetDataView;
    procedure ShowManualData;
    procedure ReadManualData;
    procedure GetDataSetName;
    procedure GetTableName;
    procedure GetQueryName;
    procedure GetxySheetName;
    procedure GetODBCDSName;
    procedure ControlsState(state:boolean);
  public
    { Public declarations }
    property Graph:TxyGraph read Fgraph write SetXyGraph stored false;
  end;

var
  xyDataWizard: TxyDataWizard;

function ShowxyDataWizard(AOwner: TComponent; AGraph: Txygraph):boolean;

implementation

{$R *.DFM}

procedure TxyDataWizard.cb_DuplicatesClick(Sender: TObject);
begin
  if not FNoUpdating then
   FSeries.allowduplicates := cb_duplicates.checked;
end;

procedure TxyDataWizard.e_toleranceChange(Sender: TObject);
begin
  if not FNoUpdating and (e_tolerance.text <> '') then
     FSeries.tolerance := strtofloat(e_tolerance.text);
end;

{------------------------------------------------------------------------------}
function ShowxyDataWizard(AOwner: TComponent; AGraph: Txygraph):boolean;
begin
  xyDataWizard := TxyDataWizard.create(AOwner);
  try
    xyDataWizard.graph := AGraph;
    if xyDataWizard.showmodal = mrOk then
      begin
      AGraph.assign(xyDataWizard.graph);
      result := true;
      end
    else
      result := false;
  finally
    xyDataWizard.free;
  end;
end;

procedure TxyDataWizard.SetxyGraph(AxyGraph:TxyGraph);
begin
  FGraph.assign(AxyGraph);
  BuildSeriesComboBox(-1);
  if seriescombobox.items.count > 0 then
    seriescombobox.itemindex := 0;
  seriesComboboxChange(Self)
end;

procedure TxyDataWizard.buildSeriesCombobox;
var p:TSeries;
    l,k,j:longint;
begin
 FNoUpdating := true;
 k := -1;
 SeriesCombobox.items.clear;
 with FGraph do
   begin
   p := SeriesHandle;
   j := 0;
   while p <> nil do
     begin
     l := p.Seriesindex;
     if l = i then k := j;
     SeriesCombobox.items.addObject(p.seriesname, TObject(l));
     p := p.nextSeries;
     inc(j);
     end;
   end;
 if k <> -1 then seriescombobox.itemindex := k;
 FNoUpdating := false;
end;

procedure TxyDataWizard.seriesComboboxChange(Sender: TObject);
begin
  if not FNoUpdating then
    if seriescombobox.itemindex > -1 then
      ShowSeries(longint(seriescombobox.Items.Objects[seriescombobox.itemindex]))
    else
      ShowSeries(-1);
end;

procedure TxyDataWizard.SetDefaults;
begin
  FNoUpdating := true;
  { FNoUpdating will be left this way for until a
    valid series is selected }
  e_seriesName.text := '';
  e_tolerance.text := '';
  cb_duplicates.checked := false;
  cb_Active.checked := false;
  radiobutton6.checked := true;
  radiobutton7.checked := false;
  cbx_points.itemindex := 0;
  b_PointColor.enabled := false;
  e_PointSize.enabled := false;
  e_PointSize.value := 0;
  cbx_lines.itemindex := 0;
  b_LineColor.enabled := false;
  cb_AutoZero.checked := false;
  e_Zero.text := '';
  {--------------------------}
  e_Headers.value := 0;
  e_Source.text := '';
  e_Headers.value := 1;
  e_RowFreq.value := 1;
  cbx_RowChoice.itemindex := 0;
  e_Start.Text := '0';
  e_end.Text := '0';
  cbx_Colselecttype.itemindex := 0;
  e_width.value := 10;
  cbx_XCol.itemindex := 0;
  cbx_YCol.itemindex := 0;
  {--------------------------}
  cbx_regression.itemindex := 0;
  e_RegCtrl1.text := '';
  e_RegCtrl2.text := '';
  cbx_regrLine.itemindex := 0;
  cbx_Bounds.itemindex := 0;
  e_BoundLow.text := '';
  e_BoundUp.text := '';
  cbx_BoundsLine.itemindex := 0;
end;

procedure TxyDataWizard.ControlsState(state:boolean);
begin
    {-------------- general page --------------}
    e_seriesName.enabled := state;
    e_tolerance.enabled := state;
    cb_duplicates.enabled := state;
    cb_Active.enabled := state;
    radiobutton6.enabled := state;
    radiobutton7.enabled := state;
    cbx_points.enabled := state;
    b_PointColor.enabled := state;
    e_PointSize.enabled := state;
    e_PointSize.enabled := state;
    cbx_lines.enabled := state;
    b_LineColor.enabled := state;
    cb_AutoZero.enabled := state;
    e_Zero.enabled := state;
    b_PointColor.enabled := state;
    b_LineColor.enabled := state;
    {-------------- datasource page --------------}
    cbx_Source.enabled := state;
    e_Source.enabled := state;
    button1.enabled := state;
    e_Headers.enabled := state;
    e_RowFreq.enabled := state;
    cbx_RowChoice.enabled := state;
    e_Start.enabled := state;
    e_end.enabled := state;
    cbx_Colselecttype.enabled := state;
    e_width.enabled := state;
    cbx_XCol.enabled := state;
    cbx_YCol.enabled := state;
    {-------------- stats page -------------------}
    cbx_regression.enabled := state;
    e_RegCtrl1.enabled := state;
    e_RegCtrl2.enabled := state;
    cbx_regrLine.enabled := state;
    cbx_Bounds.enabled := state;
    e_BoundLow.enabled := state;
    e_BoundUp.enabled := state;
    cbx_BoundsLine.enabled := state;
    b_RegrColor.enabled := state;
    b_BoundsColor.enabled := state;
end;

procedure TxyDataWizard.showseries(i:integer);
begin
  FNoUpdating := true;
  if i = -1 then
    FSeries := nil
  else
    FSeries := FGraph.Series[i];
  if Fseries = nil then
    begin
    setDefaults;
    ControlsState(false);
    end
  else
  with FSeries do
    begin
    ControlsState(true);
    {-------------- general page --------------}
    e_seriesName.text := Seriesname;
    e_tolerance.text := floattostr(tolerance);
    cb_duplicates.checked := allowduplicates;
    cb_Active.checked := active;
    radiobutton6.checked := not (WhichYAxis = Fgraph.YAxis_second);
    radiobutton7.checked := (WhichYAxis = Fgraph.YAxis_second);
    if not drawpoints then cbx_points.itemindex := 0
     else
      case pointshape of
        ps_Square:cbx_points.itemindex := 1;
        ps_Circle:cbx_points.itemindex := 2;
        ps_Diamond:cbx_points.itemindex := 3;
        ps_Cross:cbx_points.itemindex := 4;
        ps_Wide:cbx_points.itemindex := 5;
      end;
    b_PointColor.enabled := (cbx_points.itemindex > 0);
    e_PointSize.enabled := (cbx_points.itemindex > 0);
    e_PointSize.value := pointsize;
    if not drawline then cbx_lines.itemindex := 0
     else
      case linestyle of
        psSolid:cbx_lines.itemindex := 1;
        psDash:cbx_lines.itemindex := 2;
        psDot:cbx_lines.itemindex := 3;
        psDashDot:cbx_lines.itemindex := 4;
        psDashDotDot:cbx_lines.itemindex := 5;
      end;
    b_LineColor.enabled := (cbx_lines.itemindex > 0);
    cb_AutoZero.checked := autozero;
    e_Zero.text := floattostrF(Internalzero,FFFixed,2,4);
    {-------------- datasource page --------------}
    case DataSrc of
      ds_Manual:cbx_Source.ItemIndex := 0;
      ds_TextFile:cbx_Source.ItemIndex := 1;
      ds_DataSet:cbx_Source.ItemIndex := 2;
      ds_BDETable:cbx_Source.ItemIndex := 3;
      ds_BDEQuery:cbx_Source.ItemIndex := 4;
      ds_xyHolder:cbx_Source.ItemIndex := 5;
      ds_ODBC:cbx_Source.ItemIndex := 6;
    end;
    WasManual := DataSrc = ds_Manual;
    e_Source.text := SrcInfo;

    e_Headers.value := HeaderCount;
    e_RowFreq.value := RowHitFreq;
    case RowChoice of
      rc_all:cbx_RowChoice.itemindex := 0;
      rc_starttoall:cbx_RowChoice.itemindex := 1;
      rc_alltoend:cbx_RowChoice.itemindex := 2;
      rc_starttoend:cbx_RowChoice.itemindex := 3;
      rc_firstXNum:cbx_RowChoice.itemindex := 4;
      rc_lastXNum:cbx_RowChoice.itemindex := 5;
    end;
    e_Start.text :=  floattostrF(RowStart,FFFixed,2,4);
    e_end.text := floattostrF(RowFinish,FFFixed,2,4);

   if FSeries.TextFileByWidth then
     begin
     cbx_Colselecttype.itemindex := 0;
     e_width.visible := true;
     end
   else
     begin
     cbx_Colselecttype.itemindex := 1;
     e_width.visible := false;
     end;
    e_width.value := ColWidth;
    checkbox1.checked := XFormat = ft_DateTime;

    setDataView;

    cbx_XCol.Itemindex := cbx_XCol.Items.indexof(XDataCol);
    cbx_YCol.Itemindex := cbx_YCol.Items.indexof(YDataCol);

    {-------------- stats page -------------------}
    case regtype of
      rg_None:cbx_regression.itemindex := 0;
      rg_Linear:cbx_regression.itemindex := 1;
      rg_passingBablok:cbx_regression.itemindex := 2;
      rg_quadratic:cbx_regression.itemindex := 3;
      rg_Spline:cbx_regression.itemindex := 4;
      rg_dwls:cbx_regression.itemindex := 5;
      rg_RunningAverage:cbx_regression.itemindex := 6;
    end;
    cbx_RegressionChange(self);
    e_RegCtrl1.text := inttostr(regcontrol1);
    e_RegCtrl2.text := floattostrF(regcontrol2,FFFixed,2,4);
    case RegressionLineStyle of
      psSolid:cbx_regrLine.itemindex := 0;
      psDash:cbx_regrLine.itemindex := 1;
      psDot:cbx_regrLine.itemindex := 2;
      psDashDot:cbx_regrLine.itemindex := 3;
      psDashDotDot:cbx_regrLine.itemindex := 4;
    end;
    case BoundsType of
      bt_None: cbx_Bounds.itemindex := 0;
      bt_AsSet:cbx_Bounds.itemindex := 1;
      bt_1SD:  cbx_Bounds.itemindex := 2;
      bt_2SD:  cbx_Bounds.itemindex := 3;
      bt_3SD:  cbx_Bounds.itemindex := 4;
      bt_allSD:cbx_Bounds.itemindex := 5;
     end;
    e_BoundLow.text := floattostrF(LowerBound,FFFixed,2,4);
    e_BoundUp.text := floattostrF(UpperBound,FFFixed,2,4);
    case BoundsLineStyle of
        psSolid:cbx_BoundsLine.itemindex := 0;
        psDash:cbx_BoundsLine.itemindex := 1;
        psDot:cbx_BoundsLine.itemindex := 2;
        psDashDot:cbx_BoundsLine.itemindex := 3;
        psDashDotDot:cbx_BoundsLine.itemindex := 4;
      end;
    FNoUpdating := false;
    end;
end;

procedure TxyDataWizard.Button5Click(Sender: TObject);
begin
 with seriescombobox do
  if itemindex = -1 then
   messagedlg('There is no series selected', mterror, [mbok], 0)
 else
  if messagedlg('Delete series '
        + fgraph[longint(items.objects[itemindex])].seriesname
          + ' permanently, are you sure?',
              mtconfirmation, [mbyes, mbno],0) = mrYes then
    begin
    fgraph[longint(items.objects[itemindex])].free;
    BuildSeriesComboBox(-1);
    if seriescombobox.items.count > 0 then
      seriescombobox.itemindex := 0;
    seriesComboboxChange(Self)
    end;
end;

procedure TxyDataWizard.BitBtn18Click(Sender: TObject);
var i:integer;
begin
  i := Fgraph.LastSeriesIndex + 1;
  {force creation of series}
  Fgraph[i].SeriesName := 'New Series ' + inttostr(i);
  buildSeriesComboBox(i);
{  if seriescombobox.items.count > 0 then
      seriescombobox.itemindex := 0;}
  seriesComboboxChange(Self)
end;

procedure TxyDataWizard.BitBtn3Click(Sender: TObject);
begin
  if InPreview then
    begin
    notebook2.pageindex := 1;
    InPreview := false;
    BitBtn3.Caption := 'Pre&view';
    end
  else
    begin
    if (FSeries <> nil) then
      if (FSeries.DataSrc = ds_Manual) then
        readManualData
      else
        FSeries.Refreshdata;
    notebook2.pageindex := 0;
    InPreview := true;
    BitBtn3.Caption := '&Edit';
    end;
end;

procedure TxyDataWizard.FormCreate(Sender: TObject);
begin
  InPreview := false;
end;


{------------------------------------------------------------------------------}
procedure TxyDataWizard.e_SeriesNameChange(Sender: TObject);
var i:integer;
begin
  if not FNoUpdating then
    with seriescombobox do
      begin
      Fgraph[longint(items.objects[itemindex])].
      seriesname := e_seriesname.text;
      {stupid tstrings resets itemindex during next process}
      i := itemindex;
      items[i] := e_seriesname.text;
      itemindex := i;
      end;
end;

procedure TxyDataWizard.cb_ActiveClick(Sender: TObject);
begin
  if not FNoUpdating then FSeries.active := cb_Active.checked;
end;

procedure TxyDataWizard.RadioButton6Click(Sender: TObject);
begin
  if not FNoUpdating then
    if TComponent(sender).tag = 2 then
      FSeries.WhichYAxis := Fgraph.YAxis_second
    else
      FSeries.WhichYAxis := Fgraph.YAxis;
end;

procedure TxyDataWizard.cbx_pointsChange(Sender: TObject);
begin
  b_pointcolor.enabled := (cbx_Points.itemindex > 0);
  e_PointSize.enabled := (cbx_Points.itemindex > 0);
  if FNoUpdating then exit;
  with FSeries do
    begin
    holdupdates := true;
    drawpoints := true;
    case cbx_points.itemindex of
      0:drawpoints := false;
      1:pointshape := ps_Square;
      2:pointshape := ps_Circle;
      3:pointshape := ps_Diamond;
      4:pointshape := ps_Cross;
      5:pointshape := ps_Wide;
    end;
    holdupdates := false;
    end;
end;

procedure TxyDataWizard.e_PointSizeChange(Sender: TObject);
begin
  if not FNoUpdating then FSeries.pointsize := e_PointSize.value;
end;

procedure TxyDataWizard.b_PointColorClick(Sender: TObject);
begin
 with FSeries do
  begin
  cd.color := pointcolor;
  if cd.execute then pointcolor := cd.color;
  end;
end;

procedure TxyDataWizard.cbx_LinesChange(Sender: TObject);
begin
  b_LineColor.enabled := (cbx_Lines.itemindex > 0);
  if FNoUpdating then exit;
  with FSeries do
    begin
    holdupdates := true;
    drawline := true;
    case cbx_Lines.itemindex of
      0:drawline := false;
      1:linestyle := psSolid;
      2:linestyle := psDash;
      3:linestyle := psDot;
      4:linestyle := psDashDot;
      5:linestyle := psDashDotDot;
    end;
    holdupdates := false;
    end;
end;

procedure TxyDataWizard.b_LineColorClick(Sender: TObject);
begin
 with FSeries do
  begin
  cd.color := linecolor;
  if cd.execute then linecolor := cd.color;
  end;
end;

procedure TxyDataWizard.e_ZeroChange(Sender: TObject);
begin
  if Not FNoUpdating and (e_Zero.text <> '') and (e_Zero.text <> '.') then
    FSeries.InternalZero := strtofloat(e_Zero.text);
end;

procedure TxyDataWizard.cb_AutoZeroClick(Sender: TObject);
begin
  e_Zero.enabled := not cb_AutoZero.checked;
  if Not FNoUpdating then
   with FSeries do
    begin
    autozero := cb_AutoZero.checked;
    FNoUpdating := true;
    e_Zero.text := floattostrF(internalzero,FFFixed,2,4);
    FNoUpdating := false;
    end;
end;

{------------------------------------------------------------------------------}
procedure TxyDataWizard.cbx_RegressionChange(Sender: TObject);
begin
  cbx_RegrLine.enabled := cbx_Regression.itemindex > 0;
  b_RegrColor.enabled := cbx_Regression.itemindex > 0;
  case cbx_Regression.itemindex of
   0..3:begin
     l_RegCtrl1.caption := 'Value not used';
     l_RegCtrl2.caption := 'Value not used';
     end;
   4:begin
     l_RegCtrl1.caption := 'Number of Points:';
     l_RegCtrl2.caption := 'Gradient at ends:';
     end;
   5:begin
     l_RegCtrl1.caption := 'Number of Points:';
     l_RegCtrl2.caption := 'Fitting Tension:';
     end;
   6:begin
     l_RegCtrl1.caption := 'Value not used';
     l_RegCtrl2.caption := 'Alpha value:';
     end;
  end;
  if FNoUpdating then exit;
  with FSeries do
    case cbx_Regression.itemindex of
     0:RegType := rg_none;
     1:RegType := rg_Linear;
     2:RegType := rg_passingBablok;
     3:RegType := rg_quadratic;
     4:RegType := rg_Spline;
     5:RegType := rg_dwls;
     6:RegType := rg_RunningAverage;
    end;
end;

procedure TxyDataWizard.e_RegCtrl1Change(Sender: TObject);
begin
 if not FNoUpdating and (e_RegCtrl1.text <> '') then
   FSeries.regcontrol1 := strtoint(e_RegCtrl1.text);
end;

procedure TxyDataWizard.e_RegCtrl2Change(Sender: TObject);
begin
 if not FNoUpdating and (e_RegCtrl2.text <> '') then
   FSeries.regcontrol2 := strtofloat(e_RegCtrl2.text);
end;

procedure TxyDataWizard.cbx_RegrLineChange(Sender: TObject);
begin
  if FNoUpdating then exit;
  with FSeries do
    case cbx_RegrLine.itemindex of
      0:RegressionLineStyle := psSolid;
      1:RegressionLineStyle := psDash;
      2:RegressionLineStyle := psDot;
      3:RegressionLineStyle := psDashDot;
      4:RegressionLineStyle := psDashDotDot;
    end;
end;

procedure TxyDataWizard.b_RegrColorClick(Sender: TObject);
begin
 with FSeries do
  begin
  cd.color := RegressionLineColor;
  if cd.execute then RegressionLineColor := cd.color;
  end;
end;

procedure TxyDataWizard.cbx_BoundsChange(Sender: TObject);
begin
  with cbx_Bounds do
    begin
    b_BoundsColor.enabled := (itemindex <> 0);
    cbx_BoundsLine.enabled := (itemindex <> 0);
    e_BoundUp.enabled := (itemindex = 1);
    e_BoundLow.enabled := (itemindex = 1);
    end;
  if FNoUpdating then exit;
  with FSeries do
   case cbx_Bounds.itemindex of
    0:boundstype := bt_None;
    1:boundstype := bt_AsSet;
    2:begin
      boundstype := bt_1SD;
      {$IFDEF STATISTICS}
      showmessage('Mean = '+floattostr(YStats.Mean));
      showmessage('SD = '+floattostr(YStats.SD));
      {$ENDIF}
      end;
    3:boundstype := bt_2SD;
    4:boundstype := bt_3SD;
    5:boundstype := bt_allSD;
  end;
end;

procedure TxyDataWizard.e_BoundLowChange(Sender: TObject);
begin
  if Not FNoUpdating then FSeries.lowerbound := strtofloat(e_BoundLow.text);
end;

procedure TxyDataWizard.e_BoundUpChange(Sender: TObject);
begin
  if not FNoUpdating then FSeries.upperbound := strtofloat(e_BoundUp.text);
end;

procedure TxyDataWizard.cbx_BoundsLineChange(Sender: TObject);
begin
 if FNoUpdating then exit;
  with FSeries do
    case cbx_BoundsLine.itemindex of
      0:BoundsLineStyle := psSolid;
      1:BoundsLineStyle := psDash;
      2:BoundsLineStyle := psDot;
      3:BoundsLineStyle := psDashDot;
      4:BoundsLineStyle := psDashDotDot;
    end;
end;

procedure TxyDataWizard.b_BoundsColorClick(Sender: TObject);
begin
  with FSeries do
    begin
    cd.color := boundscolor;
    if cd.execute then boundscolor := cd.color;
    end;
end;

{------------------------------------------------------------------------------}

procedure TxyDataWizard.e_HeadersChange(Sender: TObject);
begin
   if not FNoUpdating then
     begin
     FSeries.HeaderCount := e_Headers.value;
     setdataview;
     end;
end;

procedure TxyDataWizard.e_RowFreqChange(Sender: TObject);
begin
   if not FNoUpdating then Fseries.RowHitFreq := e_RowFreq.value;
end;

procedure TxyDataWizard.cbx_SourceChange(Sender: TObject);
var isManual:boolean;
begin
  if FNoUpdating then exit;
  case cbx_Source.ItemIndex of
    0:FSeries.DataSrc := ds_Manual;
    1:FSeries.DataSrc := ds_TextFile;
    2:FSeries.DataSrc := ds_DataSet;
    3:FSeries.DataSrc := ds_BDETable;
    4:FSeries.DataSrc := ds_BDEQuery;
    5:FSeries.DataSrc := ds_xyHolder;
    6:FSeries.DataSrc := ds_ODBC;
  end;
  isManual := (cbx_Source.ItemIndex = 0);
  if isManual <> WasManual then
    if isManual = true then
       begin
       if Messagedlg('Do you want to keep your data?',
                      mtConfirmation, [mbyes,mbno], 0) = mrYes then
         FSeries.refreshdata
       else
         FSeries.clear;
       end
    else
      begin
      if(FSeries.Data <> nil) and (MessageDlg('Series Data Will be lost, Continue?', mtConfirmation,
                     [mbyes,mbno], 0) = mrNo) then
        begin
        cbx_Source.Itemindex := 0;
        exit;
        end;
      end;
  WasManual := isManual;
  if (FSeries.dataSrc = ds_xyHolder) or (FSeries.dataSrc = ds_TextFile) then
    FSeries.HeaderCount := 1
  else
    FSeries.HeaderCount := 0;
  SetDataView;
end;

procedure TxyDataWizard.cbx_RowChoiceChange(Sender: TObject);
begin
  if FNoUpdating then exit;
  case cbx_RowChoice.itemindex of
    0:Fseries.RowChoice := rc_all;
    1:Fseries.RowChoice := rc_starttoall;
    2:Fseries.RowChoice := rc_alltoend;
    3:Fseries.RowChoice := rc_starttoend;
    4:Fseries.RowChoice := rc_firstXNum;
    5:Fseries.RowChoice := rc_lastXNum;
  end;
end;

procedure TxyDataWizard.e_startChange(Sender: TObject);
begin
  If Not FNoUpdating then Fseries.RowStart := strtofloat(e_Start.text);
end;

procedure TxyDataWizard.e_endChange(Sender: TObject);
begin
  If Not FNoUpdating then Fseries.RowFinish := strtofloat(e_end.text);
end;

procedure TxyDataWizard.cbx_ColselecttypeChange(Sender: TObject);
begin
 If Not FNoUpdating then
   begin
   FSeries.TextFileByWidth := (cbx_Colselecttype.itemindex = 0);
   setDataView;
   end;
end;

procedure TxyDataWizard.e_widthChange(Sender: TObject);
begin
  if not FNoUpdating then
    begin
    FSeries.ColWidth := e_width.value;
    SetDataView;
    end;
end;

procedure TxyDataWizard.cbx_XcolChange(Sender: TObject);
begin
  If Not FNoUpdating then
    FSeries.XDataCol := cbx_XCol.Items[cbx_XCol.ItemIndex];
end;

procedure TxyDataWizard.cbx_YColChange(Sender: TObject);
begin
  If Not FNoUpdating then
    FSeries.YDataCol := cbx_YCol.Items[cbx_YCol.ItemIndex];
end;

procedure TxyDataWizard.ShowManualData;
var p:pgpoint;
    i:integer;
    asDate:boolean;
begin
  asDate := fgraph.XAxis.ShowAsTime;
  CheckBox1.Checked := AsDate;
  notebook1.height := 30;
  notebook1.pageindex := 1;
  grid.options := grid.options + [goEditing];
  ClearGrid;
  with grid do
    begin
    ColCount := 2;
    RowCount := FSeries.PointNumber+2;
    FixedRows := 1;
    cells[0,0] := 'X Data';
    cells[1,0] := 'Y Data';
    i := 1;
    p := FSeries.Data;
    while p <> nil do
      begin
      if not asDate then
        cells[0,i] := FloattoStr(p^.xv)
      else
        cells[0,i] := DateTimetoStr(p^.xv);
      cells[1,i] := FloattoStr(p^.yv);
      p := p^.next;
      inc(i);
      end;
    end;
end;

procedure TxyDataWizard.upDateDataControls;
begin
  if cbx_Source.itemindex = 0 then
    begin
    e_source.enabled := false;
    Button1.enabled := false;
    end
  else
    begin
    e_source.enabled := true;
    Button1.enabled := true;
    If (cbx_Source.itemindex = 1) or (cbx_Source.itemindex = 5) then
      begin
      cbx_ColSelecttype.enabled := true;
      e_width.enabled := true;
      end
    else
      begin
      cbx_ColSelecttype.enabled := false;
      e_width.enabled := false;
      end;
    end;
  if cbx_Colselecttype.itemindex = 0 then
    e_width.visible := true
  else
    e_width.visible := false;
end;

procedure TxyDataWizard.ClearGrid;
var i:integer;
begin
  with grid do
    begin
    for i := grid.ColCount - 1 downto 0 do grid.cols[i].clear;
    Colcount := 1;
    rowCount := 1;
    end;
end;

procedure TxyDataWizard.setupgrid(ds:TDataSupplier);
begin
  if (ds = nil) or (ds.GetColCount = 0) or (ds.GetRowCount = 0) then
    begin
    grid.DefaultColWidth := 100;
    grid.cellS[0,0] := 'Invalid Data Source';
    end
  else
    with grid do
      begin
      DefaultColWidth := width div ds.GetColCount;
      ColCount := ds.GetColCount;
{      if ds.IsText then
        begin
        RowCount := row_scan_depth;
        FixedRows := FSeries.HeaderCount;
        end
      else
        begin
        RowCount := row_scan_depth + 1;
        FixedRows := FSeries.HeaderCount + 1;
        end;}
        RowCount := row_scan_depth + 1;
        FixedRows := 1;
      end;
end;

Procedure TxyDataWizard.AddHeaderRows(ds:TDataSupplier);
var i, xin,yin:integer;
    s:string;
begin
  xin := cbx_Xcol.itemindex;
  cbx_Xcol.items.clear;
  yin := cbx_Ycol.itemindex;
  cbx_Ycol.items.clear;
  with grid,ds do
    for i := 0 to GetColCount-1 do
      begin
      s := GetColTitle(i);
      Cells[i,0] := s;
      cbx_Xcol.items.add(s);
      cbx_Ycol.items.add(s);
      end;
  cbx_Xcol.itemindex := xin;
  cbx_Ycol.itemindex := yin;
  FGridOffset := 1;
end;

procedure TxyDataWizard.setDataView;
var ds:TDataSupplier;
    var i,j:integer;
begin
  if FSeries.DataSrc = ds_manual then
    begin
    ShowManualData;
    exit;
    end;
  notebook1.height := 60;
  notebook1.pageindex := 0;
  upDateDataControls;
  ClearGrid;
  with FSeries do
    ds := initdataSupplier(DataSrc, SrcInfo, TextFileByWidth,
             ColWidth, TextSeparators, TextMarkers);
  try
    setupgrid(ds);
    if ds = nil then
     begin
     messagebeep($FFFF);
     exit;
     end;
    AddHeaderRows(ds);
    with grid do
      begin
      i := 0;
      while not ds.TestEndData and (i < FSeries.HeaderCount) do
        begin
        inc(i);
        ds.NextRow;
        end;
      i := 0;
      while not ds.TestEndData and (i < Row_Scan_depth) do
        begin
        for j := 0 to ds.GetColCount - 1 do
          grid.cells[j,i+FGridOffset] := ds.CellText(j);
        ds.nextrow;
        inc(i);
        end;
      end;
  finally
    ds.free;
  end;
end;

procedure TxyDataWizard.SpeedButton2Click(Sender: TObject);
var sel:TGridRect;
    i:integer;
begin
  if FNoUpdating then exit;
  sel := grid.Selection;
  if sel.bottom = 0 then sel.bottom := 1;
  with grid do
    begin
    rowcount := grid.RowCount + 1;
    for i := rowcount downto sel.bottom + 1 do
      begin
      Cells[0,i] := Cells[0,i-1];
      Cells[1,i] := Cells[1,i-1];
      end;
    Cells[0,sel.bottom] := '';
    Cells[1,sel.bottom] := '';
    end;
  sel.left := 0;
  sel.right := 0;
  sel.top := sel.bottom;
  grid.selection := sel;
  ReadManualData;
end;

procedure TxyDataWizard.SpeedButton3Click(Sender: TObject);
var sel:TGridRect;
    i,selHeight:integer;
begin
  if FNoUpdating then exit;
  sel := grid.Selection;
  with grid do
    begin
    SelHeight := sel.Bottom - Sel.Top + 1;
    for i := sel.top to Rowcount - SelHeight do
      begin
      Cells[0,i] := Cells[0,i+SelHeight];
      Cells[1,i] := Cells[1,i+SelHeight];
      end;
    rowcount := grid.RowCount - SelHeight;
    end;
  ReadManualData;
end;

procedure TxyDataWizard.SpeedButton1Click(Sender: TObject);
begin
  if FNoUpdating then exit;
  FSeries.Clear;
  ShowManualData;
end;

procedure TxyDataWizard.ReadManualData;
var i:integer;
    xv,yv:double;
begin
  with FSeries do
    begin
    Clear;
    for i := 1 to grid.rowcount - 1 do
      try
        if checkbox1.checked then
          xv := StrtoDateTime(grid.cells[0, i])
        else
          xv := StrtoFloat(grid.cells[0, i]);
        yv := StrtoFloat(grid.cells[1, i]);
        add(xv,yv);
      except
      end;
    end;
end;

procedure TxyDataWizard.SpeedButton4Click(Sender: TObject);
begin
  if FNoUpdating then exit;
  readManualData;
end;

procedure TxyDataWizard.SpeedButton5Click(Sender: TObject);
begin
  if FNoUpdating then exit;
  readManualData;
  ShowManualData;
end;

procedure TxyDataWizard.BitBtn1Click(Sender: TObject);
begin
  try
    if (FSeries <> nil) then
      if (FSeries.DataSrc = ds_Manual) then
        readManualData
      else
        FSeries.refreshdata;
    modalresult := mrOK;
  except
    if messagedlg('The settings for the current series cause errors. Are you sure you want to exit?',
                mtwarning, [mbyes, mbno], 0) = mrYes then
      modalresult := mrOk;
  end;
end;

procedure TxyDataWizard.e_SourceDblClick(Sender: TObject);
begin
  case cbx_Source.itemindex of
    0:messagebeep($FFFF);
    1:if od.execute then
       begin
       e_source.Text := od.filename;
       SetDataView;
       end;
    2:GetDataSetName;
    3:GetTableName;
    4:GetQueryName;
    5:GetxySheetName;
    6:GetODBCDSName;
  end;
end;

procedure TxyDataWizard.Button1Click(Sender: TObject);
begin
  SetDataView;
end;

procedure TxyDataWizard.e_sourceChange(Sender: TObject);
begin
  if not FNoUpdating then Fseries.SrcInfo := e_Source.text;
end;

procedure TxyDataWizard.GetDataSetName;
begin
  xyGetDataSource := TxyGetDataSource.create(self);
  try
    with xyGetDataSource do
      begin
      notebook1.pageindex := 2;
      CurrSource := e_source.text;
      if showmodal = mrOK then
        e_source.text := listbox2.Items[listbox2.itemindex];
      end;
  finally
    xyGetDataSource.close;
    SetDataView;
  end;
end;

procedure TxyDataWizard.GetTableName;
begin
  xyGetDataSource := TxyGetDataSource.create(self);
  try
    with xyGetDataSource do
      begin
      notebook1.pageindex := 0;
      CurrSource := e_source.text;
      if showmodal = mrOK then
        e_source.text := combobox1.Items[combobox1.itemindex] + ':' +
                             listbox1.Items[listbox1.itemindex];
      end;
  finally
    xyGetDataSource.close;
    SetDataView;
  end;
end;

procedure TxyDataWizard.GetQueryName;
begin
  xyGetDataSource := TxyGetDataSource.create(self);
  try
    with xyGetDataSource do
      begin
      notebook1.pageindex := 1;
      CurrSource := e_source.text;
      if showmodal = mrOK then
        e_source.text := combobox2.items[combobox2.itemindex] + ':'+memo1.text;
      end;
  finally
    xyGetDataSource.close;
    SetDataView;
  end;
end;

procedure TxyDataWizard.GetxySheetName;
begin
  xyGetDataSource := TxyGetDataSource.create(self);
  try
    with xyGetDataSource do
      begin
      notebook1.pageindex := 3;
      CurrSource := e_source.text;
      if showmodal = mrOK then
        e_source.text := listbox3.Items[listbox3.itemindex];
      end;
  finally
    xyGetDataSource.close;
    SetDataView;
  end;
end;

procedure TxyDataWizard.GetODBCDSName;
var s:string;
begin
  xyGetDataSource := TxyGetDataSource.create(self);
  try
    with xyGetDataSource do
      begin
      notebook1.pageindex := 4;
      CurrSource := e_source.text;
      if showmodal = mrOK then
        begin
        s := combobox3.items[combobox3.itemindex];
        e_source.text := copy(s, 1, pos('(',s)-1) + ':'+memo2.text;
        end;
      end;
  finally
    xyGetDataSource.close;
    if e_source.text <> '' then SetDataView;
  end;
end;


procedure TxyDataWizard.CheckBox1Click(Sender: TObject);
begin
  if FNoUpdating then exit;
  if Checkbox1.checked then
    FSeries.XFormat := ft_DateTime
  else
    FSeries.XFormat := ft_Number;
end;

end.

